<template>
  <form class="py-4" @submit.prevent="emitSubmit">
    <div class="mb-2">
      <label
        for="website_name"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        name
      </label>
      <input
        id="website_name"
        v-model="item.name"
        :class="[
          'mt-1 w-full px-3 py-2 border rounded text-gray-800',
          violations?.name ? 'border-red-500' : 'border-gray-300',
        ]"
        type="text"
        placeholder=""
      />
      <div
        v-if="violations?.name"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.name }}
      </div>
    </div>
    <div class="mb-2">
      <label
        for="website_url"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        url
      </label>
      <input
        id="website_url"
        v-model="item.url"
        :class="[
          'mt-1 w-full px-3 py-2 border rounded text-gray-800',
          violations?.url ? 'border-red-500' : 'border-gray-300',
        ]"
        type="text"
        placeholder=""
      />
      <div
        v-if="violations?.url"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.url }}
      </div>
    </div>
    <div class="mb-2">
      <label
        for="website_books"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        books
      </label>
      <FormRepeater
        :values="item.books"
        @update="(values: any[]) => (item.books = values)"
      />
      <div
        v-if="violations?.books"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.books }}
      </div>
    </div>
    <div class="mb-2">
      <label
        for="website_statut"
        class="text-gray-700 block text-sm font-bold capitalize"
      >
        statut
      </label>
      <input
        id="website_statut"
        v-model="item.statut"
        :class="[
          'mt-1 w-full px-3 py-2 border rounded text-gray-800',
          violations?.statut ? 'border-red-500' : 'border-gray-300',
        ]"
        type="number"
        placeholder=""
      />
      <div
        v-if="violations?.statut"
        class="bg-red-100 rounded py-4 px-4 my-2 text-red-700 text-sm"
      >
        {{ violations.statut }}
      </div>
    </div>

    <button
      type="submit"
      class="px-6 py-2 bg-green-500 text-white font-medium rounded shadow-md hover:bg-green-600"
    >
      Submit
    </button>
  </form>
</template>

<script lang="ts" setup>
import { toRef, ref, type Ref } from "vue";
import FormRepeater from "@/components/common/FormRepeater.vue";
import type { Website } from "@/types/website";
import type { SubmissionErrors } from "@/types/error";

const props = defineProps<{
  values?: Website;
  errors?: SubmissionErrors;
}>();

const emit = defineEmits<{
  (e: "submit", item: Website): void;
}>();

const violations = toRef(props, "errors");

let item: Ref<Website> = ref({});

if (props.values) {
  item.value = {
    ...props.values,
  };
}

function emitSubmit() {
  emit("submit", item.value);
}
</script>
